# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Defined types**

* [`chmod_r`](#chmod_r): Recursive chmod

## Defined types

### chmod_r

Perform the equivalent of a recursive chmod (chmod -R) when required.  This
avoids having to use recursive `file` resources with large directories as this
can bring about poor performance in the Puppet Master as well as placing
high demand on storage requirements

#### Parameters

The following parameters are available in the `chmod_r` defined type.

##### `dir`

Data type: `String`

The directory to check and chmod.  Defaults to $name

Default value: $name

##### `want_mode`

Data type: `String`

The octal permissions to chmod to and check for

##### `watch`

Data type: `Optional[Resource]`

Resource reference to watch (eg Package['foo']), if set, we will
only run the chown if this resource sends a refresh event AND we identify
files with incorrect ownership.  Note that if this parameter is not set,
the chmod command will run every time find tells us we need to (eg
every puppet run)

Default value: `undef`

##### `skip`

Data type: `Optional[String]`

Do not include this directory when running chmod

Default value: `undef`

